/*  ___   ___  ___  _   _  ___   ___   ____ ___  ____  
 * / _ \ /___)/ _ \| | | |/ _ \ / _ \ / ___) _ \|    \ 
 *| |_| |___ | |_| | |_| | |_| | |_| ( (__| |_| | | | |
 * \___/(___/ \___/ \__  |\___/ \___(_)____)___/|_|_|_|
 *                 (____/ 
 * How to test encoder with Arduino
 * url: https://osoyoo.com/?p=58239
 */
 #define EC1_A 50
 #define EC1_B 51
 #define EC2_A 52
 #define EC2_B 53
 int counter1 = 0; 
 int counter2 = 0; 
 int a1State;
 int a1LastState;  
 int a2State;
 int a2LastState;  
 void setup() { 
   pinMode (EC1_A,INPUT);
   pinMode (EC1_B,INPUT);
   pinMode (EC2_A,INPUT);
   pinMode (EC2_B,INPUT);
   Serial.begin (9600);
   // Reads the initial state of the EC1_A
   a1LastState = digitalRead(EC1_A);   
 } 
 void loop() { 
   a1State = digitalRead(EC1_A); // Reads the "current" state of the EC1_A
   a2State = digitalRead(EC2_A); // Reads the "current" state of the EC1_A
   // If the previous and the current state of the EC1_A are different, that means a Pulse has occured
   if (a1State != a1LastState){     
     // If the EC1_B state is different to the EC1_A state, that means the encoder is rotating clockwise
     if (digitalRead(EC1_B) != a1State) { 
       counter1 ++;
     } else {
       counter1 --;
     }
     Serial.print("Position1: ");
     Serial.println(counter1);
   } 
   if (a2State != a2LastState){     
     // If the EC1_B state is different to the EC1_A state, that means the encoder is rotating clockwise
     if (digitalRead(EC2_B) != a2State) { 
       counter2 ++;
     } else {
       counter2 --;
     }
     Serial.print("Position2: ");
     Serial.println(counter2);
   } 
   a1LastState = a1State; // Updates the previous state of the EC1_A with the current state
   a2LastState = a2State; // Updates the previous state of the EC2_A with the current state
   
 }
